*** hybreg ***
cap program drop gelreg
program define gelreg, rclass sortpreserve

  * di "The local 0 contains the entire command line: `0'"
  syntax [anything(name=0)] [if] [in] ,[tet0(string) etype(string) intercept(real 0) intercept_iv(real 0) optfct(string) trace(real 1) lammethod(string)]
  if "`etype'" == ""{
   local penalty "EL"
  }
  if "`lammethod'" == ""{
   local lammethod "optim"
  }
  if "optfct" == ""{
    local optfct "optim"
  }

  gettoken main options: 0 , parse(",")
  
  marksample touse

  gettoken dep_exog brackets: 0, parse("(")

  gettoken dep_var exog : dep_exog

  di "Dependent Variables: `dep_var'"
  di "Exogenous Variables: `exog'"

  gettoken cntr: brackets, parse(")")

  local cntr=subinstr("`cntr'", "(", "", .)

  *di "Inside brackets: `cntr'"

  gettoken endog inst: cntr, parse("=")
  local inst=subinstr("`inst'", "=", "", .)
  local clist ""
  local i = 0
  foreach v of varlist `inst' {
    local clist "`clist' `v'"
  local i = `i'+1
  }

  local j = 0

  foreach v of varlist `endog' {
    local clist_endo "`clist_endo' `v'"
  	local j = `j'+1
  }

  capture matrix drop ivxx_names
  matrix ivxx_names = J(`i',1,1)
  matrix endo_names = J(`j',1,1)
  mat rownames ivxx_names = `clist'
  di "Endogenous Variables: `clist_endo'"
  di "Instrumental Variables: `clist'"
  
  *di "Penalty: `penalty'"
  *tokenize `inst'

  *di "`dep_var' `clist_endo' `clist' `tet0'"
  *di " `touse' `etype' `optfct'"
  * At this point we have all of the main pieces of elements we would need to run our ivreg.
  mata:m_gel("`dep_var'","`clist_endo'","`clist'","`tet0'","`touse'","`etype'","`optfct'",`intercept',`intercept_iv',`trace',"`lammethod'")
  * ivregress 2sls `dep_var' `exog' (`endog' = bs_iv*)
  * capture drop bs_iv*
  di as text  "Type of GEL: `etype'"

  mat coef = r(coefficients)
  mat lambda = r(lambda)
  mat weights = r(weights)
  mat conv_pt = r(conv_pt)
  mat conv_moment = r(conv_moment)
  mat conv_lambda = r(conv_lambda)
  mat vptest = r(vptest)


  gelreg_title, tye(coef)

  if(`intercept' == 1){
  	  local clist_endo "intercept `clist_endo'"
  }

  local j = 1
  foreach v in `clist_endo' {
    di as text   %11s abbrev("`v'",11) " " "{col 12}{c |}" "{col 17}" as result %9.0g coef[`j',1] "{col 29}"  %9.0g coef[`j',2] "{col 41}" %9.0g coef[`j',3] "{col 53}" %9.0g coef[`j',4]
  	local j = `j'+1
  }

  di as text "{hline 12}{c BT}{hline 48}"
  di ""

  gelreg_title,tye(lambda)

  if(`intercept' ==1){
	di as text   %12s "h.intercept " "{col 12}{c |}" "{col 17}" as result %9.0g lambda[1,1] "{col 29}"  %9.0g lambda[1,2] "{col 41}" %9.0g lambda[1,3] "{col 53}" %9.0g lambda[1,4]
	  forv j=2/`=rowsof(lambda)' {
	  	local ss = `j'-1
	    di as text   %12s "h`ss' " "{col 12}{c |}" "{col 17}" as result %9.0g lambda[`j',1] "{col 29}"  %9.0g lambda[`j',2] "{col 41}" %9.0g lambda[`j',3] "{col 53}" %9.0g lambda[`j',4]
	  	local j = `j'+1
	  }
	di as text "{hline 12}{c BT}{hline 48}"
  	di ""
  } 
  else{
	  forv j=1/`=rowsof(lambda)' {
	    di as text   %12s "h`j' " "{col 12}{c |}" "{col 17}" as result %9.0g lambda[`j',1] "{col 29}"  %9.0g lambda[`j',2] "{col 41}" %9.0g lambda[`j',3] "{col 53}" %9.0g lambda[`j',4]
	  	local j = `j'+1
	  }
	  	di as text "{hline 12}{c BT}{hline 48}"
  		di ""
  }


  gelreg_lamtitle
  di as text   %12s "LR test " "{col 12}{c |}" "{col 17}" as result %9.0g vptest[1,1] "{col 29}"  %9.0g vptest[1,2] 
  di as text   %12s "LM test " "{col 12}{c |}" "{col 17}" as result %9.0g vptest[2,1] "{col 29}"  %9.0g vptest[2,2] 
  di as text   %12s "J test  " "{col 12}{c |}" "{col 17}" as result %9.0g vptest[3,1] "{col 29}"  %9.0g vptest[3,2] 
  di as text "{hline 12}{c BT}{hline 24}"
  di ""

  di ""
  di "Convergence code for the coefficients: `conv_par'"

  di ""
  di "Convergence code for the lambdas: " conv_lambda[1,1]

end

cap program drop gelreg_title
program define gelreg_title
  syntax , tye(string asis)
  di ""
  if ("`tye'" == "coef"){
  	di as text  "Coefficients:"
  } 
  else{ 
  	di as text  "Lambda:"
  }
  di ""
  di as text "{hline 12}{c TT}{hline 48}"
  di as text   %12s "Variable " "{col 12}{c |}"  %12s "Estimate" "{col 24}"  %12s "t value" "{col 36}" %12s "Std. Error" "{col 48}" %12s "Pr(>|t|)"
  di as text "{hline 12}{c +}{hline 48}"

end

cap program drop gelreg_lamtitle
program define gelreg_lamtitle
   di ""
   di "Over-identifying restrictions tests: degrees of freedom is " r(ntest)
   di ""
   di as text "{hline 12}{c TT}{hline 24}"
   di as text   %12s "Variable " "{col 12}{c |}"  %12s "statistics" "{col 24}"  %12s "p-value"
   di as text "{hline 12}{c +}{hline 24}"
end

* combine_start


cap program drop hybreg
program define hybreg, rclass sortpreserve

  * di "The local 0 contains the entire command line: `0'"
  syntax [anything(name=0)] [if] [in] ,[tet0(string) method(string) types(string) intercept(real 0) intercept_iv(real 0) optfct(string) trace(real 0) lambda_method(string) lars_intercept(real 0) lars_normalize(real 0) lars_eps(real 2.220e-16)]

  if "`method'" == ""{
   local method "GEL"
  }
  if "`types'" == ""{
    if "`method'" == "GEL"{
      local types "EL"
    }
    if "`method'" == "GMM"{
      local types "twostep"
    }
    if "`method'" == "IV"{
      local types "2sls"
    }
  }

  if "`method'" == "IV" && ("`types'" != "2sls" && "`types'" != "gmm" && "`types'" != "liml"){
      local types "2sls"
  }

  if "`method'" == "GMM" && ("`types'" != "twostep" && "`types'" != "onestep" && "`types'" != "igmm"){
      local types "twostep"
  }

  if "`lambda_method'" == ""{
   local lammlambda_method "optim"
  }
  if "`optfct'" == ""{
    local optfct "optim"
  }

  gettoken main options: 0 , parse(",")
  
  marksample touse

  gettoken dep_exog brackets: 0, parse("(")

  gettoken dep_var exog : dep_exog

  di "Dependent Variables: `dep_var'"
  *di "Exogenous Variables: `exog'"

  gettoken cntr: brackets, parse(")")

  local cntr=subinstr("`cntr'", "(", "", .)

  *di "Inside brackets: `cntr'"

  gettoken endog inst: cntr, parse("=")
  local inst=subinstr("`inst'", "=", "", .)
  local clist ""
  local i = 0
  foreach v of varlist `inst' {
    local clist "`clist' `v'"
  local i = `i'+1
  }

  local j = 0

  foreach v of varlist `endog' {
    local clist_endo "`clist_endo' `v'"
    local j = `j'+1
  }

  capture matrix drop ivxx_names
  matrix ivxx_names = J(`i',1,1)
  matrix endo_names = J(`j',1,1)
  mat rownames ivxx_names = `clist'
  di "Endogenous Variables: `clist_endo'"
  di "Instrumental Variables: `clist'"
  
  *di "Penalty: `penalty'"
  *tokenize `inst'
  di ""
  di as text  "Lasso step:"

  mata:get_lars_mata("`clist'","`clist_endo'","`touse'",`lars_normalize', `lars_intercept',`trace',`lars_eps')

  mat ivs = r(ivs)

  local i = 1
  local clist_ivs ""
  foreach v of varlist `clist' {
    if ivs[`i',1]==1 {
        local clist_ivs "`clist_ivs' `v'"
    }
    local i = `i'+1
  }

  di as text  "Selected Instrumental Variables: `clist_ivs'"
  di as text  "End of Lasso step."
  di ""

  if "`method'" == "GEL" && "`types'" =="EL" {
      set more off 
  }
  
  if "`method'" == "GEL" {
    *di "`dep_var' `clist_endo' `clist' `tet0'"
    *di " `touse' `types' `optfct'"
    * At this point we have all of the main pieces of elements we would need to run our ivreg.
    mata:m_gel("`dep_var'","`clist_endo'","`clist_ivs'","`tet0'","`touse'","`types'","`optfct'",`intercept',`intercept_iv',`trace',"`lambda_method'")
    * ivregress 2sls `dep_var' `exog' (`endog' = bs_iv*)
    * capture drop bs_iv*
    di as text  "Type of GEL: `types'"

    mat coef = r(coefficients)
    mat lambda = r(lambda)
    mat weights = r(weights)
    mat conv_pt = r(conv_pt)
    mat conv_moment = r(conv_moment)
    mat conv_lambda = r(conv_lambda)
    mat vptest = r(vptest)


    gelreg_title, tye(coef)

    if(`intercept' == 1){
        local clist_endo "intercept `clist_endo'"
    }

    local j = 1
    foreach v in `clist_endo' {
      di as text   %11s abbrev("`v'",11) " " "{col 12}{c |}" "{col 17}" as result %9.0g coef[`j',1] "{col 29}"  %9.0g coef[`j',2] "{col 41}" %9.0g coef[`j',3] "{col 53}" %9.0g coef[`j',4]
      local j = `j'+1
    }

    di as text "{hline 12}{c BT}{hline 48}"
    di ""

    gelreg_title,tye(lambda)

    if(`intercept' ==1){
    di as text   %12s "h.intercept " "{col 12}{c |}" "{col 17}" as result %9.0g lambda[1,1] "{col 29}"  %9.0g lambda[1,2] "{col 41}" %9.0g lambda[1,3] "{col 53}" %9.0g lambda[1,4]
      forv j=2/`=rowsof(lambda)' {
        local ss = `j'-1
        di as text   %12s "h`ss' " "{col 12}{c |}" "{col 17}" as result %9.0g lambda[`j',1] "{col 29}"  %9.0g lambda[`j',2] "{col 41}" %9.0g lambda[`j',3] "{col 53}" %9.0g lambda[`j',4]
        local j = `j'+1
      }
    di as text "{hline 12}{c BT}{hline 48}"
      di ""
    } 
    else{
      forv j=1/`=rowsof(lambda)' {
        di as text   %12s "h`j' " "{col 12}{c |}" "{col 17}" as result %9.0g lambda[`j',1] "{col 29}"  %9.0g lambda[`j',2] "{col 41}" %9.0g lambda[`j',3] "{col 53}" %9.0g lambda[`j',4]
        local j = `j'+1
      }
        di as text "{hline 12}{c BT}{hline 48}"
        di ""
    }


    gelreg_lamtitle
    di as text   %12s "LR test " "{col 12}{c |}" "{col 17}" as result %9.0g vptest[1,1] "{col 29}"  %9.0g vptest[1,2] 
    di as text   %12s "LM test " "{col 12}{c |}" "{col 17}" as result %9.0g vptest[2,1] "{col 29}"  %9.0g vptest[2,2] 
    di as text   %12s "J test  " "{col 12}{c |}" "{col 17}" as result %9.0g vptest[3,1] "{col 29}"  %9.0g vptest[3,2] 
    di as text "{hline 12}{c BT}{hline 24}"
    di ""

    di ""
    di "Convergence code for the coefficients: `conv_par'"

    di ""
    di "Convergence code for the lambdas: " conv_lambda[1,1]
  }

  if "`method'" == "IV" {
    if `intercept' == 1{
    ivregress `types' `dep_var' (`clist_endo' = `clist_ivs')
    } 
    else{
    ivregress `types' `dep_var' (`clist_endo' = `clist_ivs'),noconstant
    }
  }

  if "`method'" == "GMM" {
  	
  	mata:get_tet0("`tet0'")

  	local from_text ""
  	local j = 1
    foreach v in `clist_endo' {
    	if `j' >rowsof(temp_tet0) {
    		di "Error: The length of initial value does not match the number of regressors\n"
    		exit(232)
    	}
    	local gel_ttt = temp_tet0[`j',1]
    	local from_text "`from_text' b_`v' `gel_ttt' "
    	local j = `j' + 1
    }

    if `intercept' == 1{

    	if `intercept_iv' == 1{
   				gmm (`dep_var' - {b: `clist_endo'} - {intercept}),  inst(`clist_ivs') `types' from(`from_text')
    	}
    		else{
    			    gmm (`dep_var' - {b: `clist_endo'} - {intercept}),  inst(`clist_ivs',noconstant) `types' from(`from_text')
    		}

  }
  else{
  		if `intercept_iv' == 1{

    gmm (`dep_var' - {b: `clist_endo'}),  inst(`clist_ivs') `types' from(`from_text')

  		}
  		else{

    gmm (`dep_var' - {b: `clist_endo'}),  inst(`clist_ivs',noconstant) `types' from(`from_text')
  		    		}
  }
}

end

*** hybreg ***