{smcl}
{*  12 Feb 2014}{...}
{cmd:help lars}
{hline}

{title:Title}

    {hi:hybird GEL Estimation}

{title:Syntax}

{p 8 17 2}
{cmd:hybreg} {depvar} 
{cmd:(}{it:{help varlist:varlist2}} {cmd:=}
        {it:{help varlist:varlist_iv}}{cmd:)} {ifin}
[{cmd:,} {it:options} tet0(string) method(string) types(string) intercept(real 0) intercept_iv(real 0) optfct(string) trace(real 0) lambda_method(string) lars_intercept(real 0) lars_normalize(real 0) lars_eps(real 2.220e-16)]

{synoptset 24 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Main}

{synopt:{opt trace(real)}}If it is 1, information is printed during the running of steps.{p_end}
{synopt:{opt tet0(varlist)}}Initail values for endogenous variables{p_end}
{synopt:{opt method(string)}}Choose from GMM, GEL or IV{p_end}
{synopt:{opt types(string)}}GMM: onestep, twostep, igmm. GEL: CUE, ET, EL. IV: 2sls, liml, gmm. {p_end}
{synopt:{opt optfct(string)}}Optimation types. {p_end}
{synopt:{opt intercept(real)}}Add intercept. {p_end}
{synopt:{opt intercept_iv(real)}}Add intercept in IVs.  {p_end}
{synopt:{opt lars_intercept(real)}}Add intercept in Lasso. {p_end}
{synopt:{opt lars_normalize(real)}}Normalization in Lasso. {p_end}


{p2colreset}{...}

{title:Description}

{pstd}
We use adaptive lasso estimator to select between relevant and irrelevant instruments in heteroskedastic and non Gaussian data. To do so limit theory of Zou (2006) is extended from univariate iid case. Then we use the selected instruments in generalized empirical likelihood esti-mators (GEL). In this sense, these are called hybrid GEL. 

{pstd}
The method implemented here is {hi: Least Angle Regression} but the same algorithm can be used to get the {hi:Lasso} solution. It is a port of the LARS package written by Hastie and Efron.

{title:Examples}

{pstd}
The command can be demonstrated by clicking the text below

{pstd}
{stata sysuse hybreg_multi,replace} <---- click to load up dataset *the old dataset is lost*!

{phang}
{stata generate var7 = 0.5 in 1}

{phang}
{stata replace var7 = 0.5 in 2}

{phang}
{stata rename var7 tet0}

{phang}
{stata db hybreg}

{phang}
{stata hybreg y ( x1 x2 = z1 z2 z3 ), trace(0) method(GEL) types(CUE) intercept(0) tet0(tet0) lars_normalize(0) lars_intercept(0) optfct(optim)}

{title:Saved Results}

{dlgtab:GEL}
    {bf:r(ivs)}  {col 17} Selected IVs
    {bf:r(coefficients)} {col 17}The beta coefficients

{dlgtab:GMM}
    {bf:r(ivs)}  {col 17} Selected IVs
    {bf:e(b)  }{col 17} coefficient vector
    {bf:e(init)}{col 17} initial values of the estimators
    {bf:e(Wuser)}{col 17} user-supplied initial weight matrix
    {bf:e(W)   }{col 17} weight matrix used for final round of estimation
    {bf:e(S)   }{col 17} moment covariance matrix used in robust VCE 

{dlgtab:IV}
    {bf:r(ivs)}  {col 17} Selected IVs
    {bf:e(b)} {col 17} coefficient vector
    {bf:e(Cns)} {col 17} constraints matrix
    {bf:e(W)} {col 17} weight matrix used to compute GMM estimates
    {bf:e(S)} {col 17} moment covariance matrix used to compute GMM variance-covariance matrix
    {bf:e(V)} {col 17} variance-covariance matrix of the estimators
    {bf:e(V_modelbased)} {col 17} model-based variance

{title:See Also} 

{pstd}
Related commands:
{pstd}
{help sw}
